/**
 * 转协同模块对象
 * 
 * @param {Object}
 *            params
 */

var CollaborationApi = function() {

	// controller配置信息
	this.config = {
		controller : "/seeyon" + "/collaboration/collaboration.do?method=newColl"
	};

	// 创建协同传入的参数
	this.clearData();

	// 新建协同win
	this.newCollWin = null;

	// 新建协同窗口名字
	this.newCollWinName = "newCollWin" + (new Date()).getTime();
};

CollaborationApi.prototype.clearData = function() {

	this.parameters = {

		subject : "",// 标题
		bodyType : '10',// 正文类型，MainbodyType
		// HTML(10),FORM(20),TXT(30),OfficeWord(41),OfficeExcel(42),
		// WpsWord(43), WpsExcel(44),Pdf(45);
		bodyContent : '',// 正文内容, 如果是非HTML正文，这里是id
		manual : "false",// 是否通过后台代码设置协同正文
		personId : '',// 流程人员ID，目前只有人员卡片用到
		from : '',// 和原来逻辑保持一致

		// 以下参数用户在后台获取参数的
		handlerName : '',// 手动设置正文或需要获取附件的Handler
		sourceId : '',// 业务对应ID，各个模块自己设置，用于获取附件或正文
		ext : ''// 扩展信息，用户sourceId不够的情况使用
	};
}

/**
 * 新建协同，传入参数
 */
CollaborationApi.prototype.newColl = function(params) {

	// 初始化页面
	this.init(params);

	// 提交参数
	if (this.newCollWin && !this.newCollWin.closed) {
		alert($.i18n('window.already.exit.js'));//该页面已打开
		this.newCollWin.focus();
	} else {
		this.ajaxSubmit();
	}
};

// Post方式提交表单
CollaborationApi.prototype.ajaxSubmit = function() {
    var _this = this;
	// 先声明一个异步请求对象
	var xmlHttpReg = null;
	if (window.ActiveXObject) {// 如果是IE
		xmlHttpReg = new ActiveXObject("Microsoft.XMLHTTP");
	} else if (window.XMLHttpRequest) {
		xmlHttpReg = new XMLHttpRequest(); // 实例化一个xmlHttpReg
	}
	// 如果实例化成功,就调用open()方法,就开始准备向服务器发送请求
	if (xmlHttpReg != null) {
	    xmlHttpReg.onreadystatechange = function(){
	        if (xmlHttpReg.readyState == 4 && xmlHttpReg.status == 200) {//4代表执行完成
	        	var cashId = xmlHttpReg.responseText
	            _this.openWindow(cashId);
	        }
	    };
	    xmlHttpReg.open("POST", "/seeyon/collaboration/collaboration.do?method=cashTransData&trans_AppToColl=true&_rand=" + new Date().getTime()+ getA8Top().CsrfGuard.getUrlSurffix(), true);
	    xmlHttpReg.setRequestHeader("Content-Type","application/x-www-form-urlencoded; charset=UTF-8"); 
	    xmlHttpReg.send(this.formDatas());
	}
};

/**
 * 组装数据
 */
CollaborationApi.prototype.formDatas = function(){
    
    var d = {};
    for(var key in this.parameters){
        var v = this.parameters[key];
        if(v != null && v != ""){
            d[key] = v;
        }
    }
    return this.formatParams(d);
}

/**
 * 格式化数据
 */
CollaborationApi.prototype.formatParams = function(data) {
    var arr = [];
    for ( var name in data) {
        arr.push(encodeURIComponent(name) + "=" + encodeURIComponent(data[name]));
    }
    return arr.join("&");
}

/**
 * 获取打开正文内容的url
 * 
 * affairId,summaryId,processId 三个参数如果有affairId优先传affairId，如果 取不到affairId传
 * summaryId或者processId openFrom 从哪里打开的,用来控制协同处理界面右侧处理区域是否显示 从如下字符串中取值：
 * formStatistical 表单查询统计 docLib 文档中心 supervise 督办 listDone 已办列表 listPending
 * 待办列表 F8Reprot F8穿透统计 subFlow 子流程查看主流程，或者主流程查看子流程 operationId 表单使用的字段，没有可以传
 * null docAcl 文档中心权限串
 */
CollaborationApi.prototype.getCollDetailUrl = function(affairId, summaryId,
		processId, openFrom, operationId, docAcl) {
	var url = _ctxPath + "/collaboration/collaboration.do?method=summary";
	if (affairId != null && typeof (affairId) != 'undefined') {
		url += "&affairId=" + affairId;
	}
	if (summaryId != null && typeof (summaryId) != 'undefined') {
		url += "&summaryId=" + summaryId;
	}
	if (processId != null && typeof (processId) != 'undefined') {
		url += "&processId=" + processId;
	}
	if (openFrom != null && typeof (openFrom) != 'undefined') {
		url += "&openFrom=" + openFrom;
	}
	if (operationId != null && typeof (operationId) != 'undefined') {
		url += "&operationId=" + operationId;
	}
	if (docAcl != null && typeof (docAcl) != 'undefined') {
		url += "&lenPotent=" + docAcl;
	}
	return url;
}

CollaborationApi.prototype.openWindow = function(cashId) {

	var width = parseInt(screen.width) - 20;
	var height = parseInt(screen.height) - 80;

	height -= 25;

	var win = window.open(this.config.controller + "&cashId=" + cashId + getA8Top().CsrfGuard.getUrlSurffix(),
			this.newCollWinName,
			"top=0,left=0,scrollbars=yes,dialog=yes,minimizable=yes,modal=open,width="
					+ width + ",height=" + height + ",resizable=yes");
	if (win == null) {
		return;
	}

	this.newCollWin = win;

	win.focus();
	return win;
};

/**
 * 初始化函数
 * 
 * @param {Object}
 *            params
 */
CollaborationApi.prototype.init = function(params) {

	this.clearData();

	// 参数覆盖TODO
	if (params) {
		for ( var key in params) {
			if (this.parameters[key] != undefined) {
				this.parameters[key] = params[key];
			}
		}
	}
};

/**
 * 创建元素
 * 
 * @param formEle
 *            form元素
 * @param eleName
 *            input Name
 * @param eleValue
 *            input alue
 * @returns
 */
CollaborationApi.prototype.createNewFormElement = function(formEle, eleName,
		eleValue, tagName) {
	if (!tagName) {
		tagName = "input";
	}

	var newEle = document.createElement(tagName);
	newEle.setAttribute("name", eleName);
	if (tagName == "input") {
		newEle.setAttribute("type", "hidden");
	} else {
		newEle.style.display = "none";
	}
	newEle.value = eleValue;
	formEle.appendChild(newEle);
	return newEle;
};

/**
 * 协同转发协同。
 * 		param["data"] : "",//转发的数据格式:summaryId_affairId,summaryId_affairId;
 *		param["errorMsg"] : "",//不允许转发的消息(默认提示：您在以下流程中没有转发权限或该流程被设置为'不允许转发'！)
 *		param["id"] : 'showForwardDialog',// 弹出dialog的id，默认是showForwardDialog
 *		param["title"] :getA8Top().$.i18n('collaboration.transmit.col.label'),// 弹出dialog的title，默认是'转发协同'
 *		param["width"] : "511",// 转发协同弹出dialog的高度，默认511
 *		param["height"] : '400',// 转发协同弹出dialog的宽度，默认400
 *		param["transParams"] : {},//dialog需要传递的参数，默认为空
 *		param["isDrag"] : true, //弹出dialog的是否可以拖动，默认true，可以拖动
 *		param["callback"]: ""  //转发成功后的需要执行的回调函数,默认为空
 */
CollaborationApi.prototype.transmitCol = function(param) {
	var transmitColParam = initTransmitColParam(param);
	 var _$ = getA8Top().$;
	//校验协同列表是否可以转发
	try{
		var affairIds = "";
		var data = param["data"];
		var affairIdAndSummaryIds = data.split(",");
		for(var i = 0; i < affairIdAndSummaryIds.length; i++){
			if(!affairIdAndSummaryIds[i]){
				continue;
			}
			var idSplit = affairIdAndSummaryIds[i].split("_");
			if(!affairIds){
				affairIds = idSplit[1];
			}else{
				affairIds = affairIds+","+idSplit[1];
			}
		}
    	var requestCaller = new XMLHttpRequestCaller(this, "ajaxColManager", "checkForwardPermission", false);
    	requestCaller.addParameter(1, "String", affairIds);
    	var ds = requestCaller.serviceRequest();
    	if(ds.length !== 0){
    		if(transmitColParam["errorMsg"]){
    			_$.alert(transmitColParam["errorMsg"]);
    		}else{
    			_$.alert($.i18n('collaboration.grid.alert.thisSelectNotForward')+"<br><br>" + ds.join("<br>"));
    		}
    		return;
    	}
    }catch(e){
    }
   
    var dialog = _$.dialog({
        id : transmitColParam["id"],
        height:transmitColParam["height"],
        width:transmitColParam["width"],
        url : getA8Top()._ctxPath+"/collaboration/collaboration.do?method=showForward&data=" + transmitColParam["data"],
        title : transmitColParam["title"],
        targetWindow:getA8Top(),
        isClear:false,
        isDrag:transmitColParam["isDrag"],
        transParams:transmitColParam["transParams"],
        buttons: [{
            id : "okButton",
            text: _$.i18n("collaboration.button.ok.label"),
            btnType:1,
            handler: function () {
                var rv = dialog.getReturnValue();
            },
            OKFN : function(){
                dialog.close();
                try{
                	if(typeof(transmitColParam["callback"])=="function"){
                		transmitColParam["callback"]();
                	}
                }
                catch(e){
                }
            }
        }, {
            id:"cancelButton",
            text: _$.i18n("collaboration.button.cancel.label"),
            handler: function () {
                dialog.close();
            }
        }]
    });
};

function initTransmitColParam(params) {

	//默认参数
	var transmitColParameters = {
		data : "",//转发的数据格式:affairId_summaryId,affairId_summaryId;
		errorMsg : "",//不允许转发的消息(默认提示：您在以下流程中没有转发权限或该流程被设置为'不允许转发'！)
		id : 'showForwardDialog',// 弹出dialog的id，默认是showForwardDialog
		title :getA8Top().$.i18n('collaboration.transmit.col.label'),// 弹出dialog的title，默认是'转发协同'
		width : "511",// 转发协同弹出dialog的高度，默认511
		height : '400',// 转发协同弹出dialog的宽度，默认400
		transParams : {},//dialog需要传递的参数，默认为空
		isDrag : true, //弹出dialog的是否可以拖动，默认true，可以拖动
		callback: ""  //转发成功后的需要执行的回调函数,默认为空
	};
	// 参数覆盖TODO
	if (params) {
		for ( var key in params) {
			if (transmitColParameters[key] != undefined) {
				transmitColParameters[key] = params[key];
			}
		}
	}
	return transmitColParameters;
}

CollaborationApi.prototype.showSummayDialogByURL = function(url) {
	try{
        //公文、协同都是affairId，会议是Id
        var affairIdIndex = url.indexOf("affairId");
        var idIndex = url.indexOf("id");
        var id = "";
        if (affairIdIndex != -1)  {
            id = getMultyWindowId("affairId",url);
            openCtpWindow({'url':url,'id':id});
        } else if (idIndex != -1) {
            id = getMultyWindowId("id",url);
            openCtpWindow({'url':url,'id':id});
        } else {
            openCtpWindow({'url':url});
        }
    } catch (e) {
    }
};

// 创建全局变量
var collaborationApi = new CollaborationApi();