//pc设计器控件
function PcDesFactory() {
    this.commonBtns = [];
    this.seniorBtns = [];
    this.baseBtns = [];
}

function _buildBarStr(obj,clickFunc){
    var bar = new Object();
    bar.id = obj.id;
    bar.extendClass = null;
    if(bar.id ==='line'){
        bar.type = '__line';
    }else if(bar.id === 'text'){
        bar.type = '__text';
        bar.name = obj.label;
    }else{
        bar.type = obj.type;
        bar.name = obj.label;
        bar.colorType = obj.type;
        if(obj.img == "" || !obj.img){
            bar.className=null;
        }else{
            bar.className=obj.img;
        }
        bar.img = bar.className;
        bar.color = obj.color;
        bar.click = clickFunc;
    }
    if(obj.data){
        bar.data = obj.data;
    }
    bar.disabled = false;
    if(hasFormLock=="true"  ){
    	//0：流程调整类、2：提交类、3：意见回复类
        if(obj.LX == "0" || obj.LX == "2" || obj.LX == "3" ){
            bar.disabled = true;
        }
    }
    if(obj.isSubmit){
        bar.isSubmit = obj.isSubmit;
    }
    if(obj.hasSubmit){
        bar.hasSubmit = obj.hasSubmit;
    }
    if(obj.color){
        bar.color = obj.color;
    }
    if(canModifyWorkFlow == 'false'){
        bar.disabled = setDisabledByAtom(obj);
    }
    if(bar.disabled){
        bar.click = null;
        bar.colorType = 0;
    }
    
    if (!bar.desabled) {
    	//指定回退等状态置灰某些操作
    	if (!checkButtonCanUse(obj)) {
    		bar.disabled = true;
            bar.click = null;
            bar.colorType = 0;
    	}
    }
    return bar;
}
function setDisabledByAtom(button){
    var flowChangeArr = ["AddNode","JointSign","RemoveNode","Infom","moreSign"];
    if (button.hasProcessChange  || button.LX == "0" ||  $.inArray(button.id, flowChangeArr) >-1) {
        return true;
    }
    return false;
}
function _buildAdvanceBarStr(obj,clickFunc){

    // returnToolbar.push({
    // customAttr:" advanceAction='AddNode' class='nodePerm'",
    var bar = new Object();
    bar.id = obj.id;
    bar.extendClass = null;
    if(bar.id ==='line'){
        bar.type = '__line';
    }else if(bar.id === 'text'){
        bar.type = '__text';
        bar.name = obj.label;
    }else{
        bar.name = obj.label;
        bar.colorType = obj.type;
        if(obj.img == "" || !obj.img){
            bar.className=null;
        }else{
            bar.className=obj.img;
        }

        bar.handle = clickFunc;
    }
    bar.img = bar.className;
    bar.color = obj.color;
    if(obj.data){
        bar.customAttr = "data = '"+obj.data+"'";
    }
    bar.disabled = false;
    if(hasFormLock=="true"  ){
        if(obj.type == "0" || obj.type == "2" || obj.type == "3" ){
            bar.disabled = true;
        }
    }
    if(obj.isSubmit){
        bar.isSubmit = obj.isSubmit;
    }
    if(obj.hasSubmit){
        bar.hasSubmit = obj.hasSubmit;
    }
    if(obj.color){
        bar.color = obj.color;
    }
    if(canModifyWorkFlow == 'false'){
        bar.disabled = setDisabledByAtom(obj);
    }
    if(bar.disabled){
        bar.handle = null;
        bar.colorType = 0;
    }
    
    if (!bar.desabled) {
    	//指定回退等状态置灰某些操作
    	if (!checkButtonCanUse(obj)) {
    		bar.disabled = true;
            bar.click = null;
            bar.colorType = 0;
    	}
    }
    return bar;
}
//控制常用按钮在工具栏中显示或隐藏
function __showBarsFunc(jsonArr) {
    var returnToolbar= new Array();
    var size = 0;
    if(jsonArr){
        size = jsonArr.length;
    }
    if(size > 0){
        for(var i = 0 ;i<size ;i++){
            var obj  = jsonArr[i];
            if(obj.id){
                if(obj.LX && obj.LX != 6){
                    if(obj.id.indexOf("-") == 0){
                        obj.id = "_"+obj.id.substr(1);
                    }

                    if(obj.id == "line"){    //如果是下划线
                        returnToolbar.push(_buildBarStr(obj));
                    }else if(obj.id == "text"){    //如果是下划线
                        returnToolbar.push(_buildBarStr(obj));
                    }else if(obj.click == ""){//就是封装类型派发统一的方法
                        obj.click =  "customOperation";
                        returnToolbar.push(_buildBarStr(obj,eval(obj.click)));//先传空
                    }else if(obj.click != ""){
                        returnToolbar.push(_buildBarStr(obj,eval(obj.click)));//先传空
                    }
                }else{//应用磁贴
                    if(obj.id == "line"){    //如果是下划线
                        returnToolbar.push(_buildBarStr(obj));
                    }else if(obj.id == "text"){    //如果是下划线
                        returnToolbar.push(_buildBarStr(obj));
                    }else{
                        obj.data =  obj.click;
                        obj.click =  "applicationMagnet";
                        obj.id =  applicationMagnetNumber;
                        applicationMagnetNumber++;
                        returnToolbar.push(_buildBarStr(obj,eval(obj.click)));//先传空
                    }
                }
            }
        }

    }
    return returnToolbar;
}

/**
 *根据模板id  获取常用按钮集合
 * @param templateId  brief非经典模板 scriptures经典模板
 * @returns {any[]}
 */
//常用操作
PcDesFactory.prototype.getCommonBtns=function (templateId) {
    size = 0;
    var jsonArrCommonList = new Array();
    if(jsonArrCommon != ""){
        var jsonObj =  JSON.parse(jsonArrCommon);//转换为json对象
        if(jsonObj){
            size = jsonObj.length;
        }
        var isWin = v3x.isCurrentSysWindows();
        if(size > 0) {
            for (var i = 0; i < size; i++) {
            	//修改，只在win客户端上显示签章，其他客户端暂不显示
				if(isWin && obj.id == 'Sign'){
					continue;
				}
                var obj = jsonObj[i];
                obj.LX = obj.type;//因为组件原因这里转换一次
                obj.type = "";
                jsonArrCommonList.push(obj)
            }
        }
    }

    return __showBarsFunc(jsonArrCommonList);
}
//基本操作
PcDesFactory.prototype.getBaseOperations=function (templateId) {
    size = 0;
    var jsonArrBaseList = new Array();
    if(jsonArrBase != ""){
        var jsonObj =  JSON.parse(jsonArrBase);//转换为json对象
        if(jsonObj){
            size = jsonObj.length;
        }
        if(size > 0) {
            for (var i = 0; i < size; i++) {
                var obj = jsonObj[i];
                obj.LX = obj.type;
                obj.img = null;
                jsonArrBaseList.push(obj)
            }
        }
    }

    return __showBarsFunc(jsonArrBaseList);
}
var applicationMagnetNumber = 123456;//磁贴ID 伪随机
//高级操作
PcDesFactory.prototype.getSeniorBtns=function(templateId){
    var returnToolbar= new Array();
    var size = 0;
    if(jsonArradvance != ""){
        var jsonObj =  JSON.parse(jsonArradvance);//转换为json对象
        if(jsonObj){
            size = jsonObj.length;
        }
        if(size > 0){
            for(var i = 0 ;i<size ;i++){
                var obj  = jsonObj[i];

                if(obj.id){
                    if(obj.type && obj.type != 6){
                        if(obj.id.indexOf("-") == 0){
                            obj.id = "_"+obj.id.substr(1);
                        }
                        if(obj.id == "line"){    //如果是下划线
                            returnToolbar.push(_buildAdvanceBarStr(obj));
                        }else if(obj.id == "text"){
                            returnToolbar.push(_buildAdvanceBarStr(obj));
                        }else if(obj.click == ""){//就是封装类型派发统一的方法
                            obj.click =  "customOperation";
                            returnToolbar.push(_buildAdvanceBarStr(obj,eval(obj.click)));//先传空
                        }else if(obj.click != ""){
                            returnToolbar.push(_buildAdvanceBarStr(obj,eval(obj.click)));//先传空
                        }
                    }else{//应用磁贴
                        if(obj.id == "line"){    //如果是下划线
                            returnToolbar.push(_buildAdvanceBarStr(obj));
                        }else if(obj.id == "text"){
                            returnToolbar.push(_buildAdvanceBarStr(obj));
                        }else{
                            obj.data =  obj.click;
                            obj.click =  "applicationAdvanceMagnet";
                            obj.id =  applicationMagnetNumber;
                            applicationMagnetNumber++;
                            returnToolbar.push(_buildAdvanceBarStr(obj,eval(obj.click)));//先传空
                        }


                    }

                }
            }
        }
    }

    return returnToolbar;
}

PcDesFactory.prototype._initFileArea=function () {

}
PcDesFactory.prototype._initIdeaArea=function () {

}
PcDesFactory.prototype._initToolBarArea=function () {

}
PcDesFactory.prototype._initCustomerBtnArea=function (items) {
    var itemOnes = [];
    var itemTwos = [];
    $(items).each(function (index, item) {
        //如果是提交形的按钮
        if (item.type===2||item.type==='2') {
            //如果是2的按钮则表示按钮颜色采用蓝色
            if(item.hasSubmit){
                item["class"]="common_button_emphasize";
            }else{
                item["class"]="";
            }
            itemOnes.push(item);
        //    判断该按钮后面是否跟了分割线如果跟了 则一并追加
            var backItem=items[index+1];
            if(backItem!=null&&backItem.id==="line"){
                itemOnes.push(backItem);
            }
        } else {
            itemTwos.push(item);
            var backItem=items[index+1];
            //    判断该按钮后面是否跟了分割线如果跟了 则一并追加
            if(backItem!=null&&backItem.id==="line"){
                itemTwos.push(backItem);
            }
        }
    });
    //初始化用户自定义的按钮集合
    this._initCustomerToolbar(itemTwos);
    //初始化提交区域的按钮方法 将用户定义的提交类按钮放到该区域
    this._initSubmitToolBar(itemOnes);
}
//加载提交类的按钮
PcDesFactory.prototype._initSubmitToolBar = function (itemOnes) {
    //如果存在处理区域 才需要进行按钮顺序的调整
    if ($("#_dealDiv").get(0) != null) {
        
        $("#_dealDiv").append(this.getCommToolBarHtml(itemOnes, 'submitToolBtnContent'));

        var parentTopEl = $("#_dealDiv").get(0).offsetTop;
        //对数据进行分行处理
        $(".customer_submit").each(function () {
            $(this).addClass("pageNum_" + (Math.floor(($(this).get(0).offsetTop - parentTopEl - 8) / 34) + 1));
            // $(this).addClass("pageNum_" + (($(this).get(0).offsetTop - parentTopEl - 8) / 34 + 1));
        })
        //对每行数据进行倒序处理
        for (var num = 1; num < 5; num++) {
            var els = $(".pageNum_" + num);
            //如果长度大于0的 才需要进行倒序处理
            if (els.length > 0) {
                if(num!=1){

                    $(els[0]).before("<div class='customer_submit_line' style='width:100%;overflow: hidden;height:1px'></div>");
                }
                _changeELPos(els);
            }
        }
    }
}
//进行元素的调换
function _changeElByNum(els,endNum){
    for(var num=1;num<endNum;num++){
        $(els[endNum-1]).after($(els[num-1]));
    }
}
//改变元素的位置
function _changeELPos(els) {
    if(els.length===1){
        return void(0);
    }else{
        _changeElByNum(els,els.length);
    }
}

PcDesFactory.prototype.getCommonBtnHtml = function (itemObj, tempName) {
    var html = pcDesCtlTempUtils[tempName];
    itemObj["onclickEvent"]="";itemObj["itemDisabled"]="";
    //如果存在用户定义的click事件 则需要加上用户事件
    if(itemObj.click!=null&&itemObj.disabled!=true){
        var methodName = "toolbar" + itemObj.id + "_aClick";
        itemObj["onclickEvent"]= "onclick='" +methodName+ "(this)'";

        window[methodName] = function(eventEl){
            itemObj.click(eventEl);
        }
    }
    //如果按钮不可以点击 则设置disabled
    if(itemObj.disabled){
        itemObj["itemDisabled"]="disabled=true";
    }
    for (var prop in itemObj) {
        html = html.replace("${" + prop + "}", itemObj[prop]);
        html = html.replace("${" + prop + "}", itemObj[prop]);
        html = html.replace("${" + prop + "}", itemObj[prop]);
    }
    return html;
}
var pcDesCtlTempUtils = {
    commonLineHtml:'<div style="overflow:hidden;line-height:1px;height:3px;padding:2px;width:315px;float:right;margin-left: 15px;margin-bottom: 6px;"><div class="hr_heng">&nbsp;</div></div>',
    submitToolBtnContent: '<DIV class="right customer_submit" style="margin-bottom:8px;">' +
    '<INPUT ${itemDisabled} ${onclickEvent} title="${name}" class="common_button ${class} margin_r_5 hand" ' +
    'id="${id}_a" style="DISPLAY: inline-block;padding:0 4px;" type=button value="${name} ' +
    '" ></DIV>',
}
PcDesFactory.prototype.getCommToolBarHtml = function (commonBtns, tempName) {
    var htmls = [];
    var pcDesObj = this;
    $(commonBtns).each(function (index, item) {
        //表示分割线
        if (item.id === 'line') {
            htmls.push(pcDesObj.getCommonBtnHtml(item, 'commonLineHtml'));
        }else if (item.id === 'label'||item.type==='7') {
            htmls.push(pcDesObj.getCommonBtnHtml(item, 'text_info'));
        } else {
            htmls.push(pcDesObj.getCommonBtnHtml(item, tempName));
        }
    });
    return htmls.join("");
}
PcDesFactory.prototype._initCustomerToolbar=function(itemTwos){
    if($("#customerToolBar")[0]){
        var toolbars = $("#customerToolBar").toolbar({
            toolbar: itemTwos,
            borderTop:false,
            borderLeft:false,
            isPager:false,
            borderRight:false
        });
        $("#customerToolBar .toolbar_l").css("width",$("#customerToolBar").width())
        return toolbars;
    }
}
PcDesFactory.prototype._initOpinionArea=function () {

}
//获取用户按钮操作项
PcDesFactory.prototype._getCustomerBtnItem = function (commonBtns) {
    var items = [];
    var baseAry = ['Track','Archive', 'Comment', 'ContinueSubmit', 'UploadAttachment', 'UploadRelDoc', 'Opinion', 'Print', "CommonPhrase"];
    //需要对写死的按钮 进行排除
    $(commonBtns).each(function (index, item) {
        if (item.isSystem === 1 || item.isSystem === false || item.isSystem === "false") {
            items.push(item);
        } else {
            var result = $.inArray(item.id, baseAry);
            if (result < 0) {
                items.push(item);
            }
        }
    });
    return items;
}
PcDesFactory.prototype._getFileAreaItem=function () {

}
PcDesFactory.prototype._getIdeaAreaItem=function () {

}
PcDesFactory.prototype._getToolBarAreaItem=function () {

}
//初始化基础操作区域
PcDesFactory.prototype.initBaseOperationArea=function (templateType,commonBtns) {
    this.templateType=templateType;
    //初始附件操作区域
    this._initFileArea(this._getFileAreaItem(commonBtns));
    //初始化baseidea信息
    this._initIdeaArea(this._getIdeaAreaItem(commonBtns));
    //初始化toolbarArea
    this._initToolBarArea(this._getToolBarAreaItem(commonBtns));
    //初始化cutomerBtnArea
    this._initCustomerBtnArea(this._getCustomerBtnItem(commonBtns));
//    初始化意见区域
    this._initOpinionArea(commonBtns);
}
//初始化常用按钮操作区域 也就是更多按钮的左边区域的常规按钮集合
PcDesFactory.prototype.initCommonBtnArea = function (areaId,btns) {
    if($("#"+areaId)[0]){
        var toolbars = $("#"+areaId).toolbar({
            toolbar: btns,
            borderTop:false,
            borderLeft:false,
            isPager:false,
            borderRight:false
        });
        return toolbars;
    }
}
/**
 * 初始化意见区域的高度等相关信息
 */
PcDesFactory.prototype.initIdeaOptionAreaHeight=function(){
    $(".idea_opinion_area").height($(document.body).height()-224);
}
/**
 * 从简单意见输入 切换到 繁琐意见输入模式
 */
PcDesFactory.prototype.showExpandIdea=function(flag){
    if(flag){
        $(".idea_opinion_area").height($(document.body).height()-224);
        $(".simple_idea").hide();
        $(".expand_idea").show();
    }else{
        $(".idea_opinion_area").height($(document.body).height()-224);
        $(".simple_idea").show();
        $(".expand_idea").hide();
    }

}
//初始化更多下拉操作集合区域
PcDesFactory.prototype.initSeniorBtnMenuArea = function (areaId,_menuSimpleData) {
    $("#"+areaId).menuSimple({
        width:100,
      	direction:"BR",
        offsetLeft: -40,
        overflow:'auto',
        data: _menuSimpleData
    });
}
//获取开始换行的序号
PcDesFactory.prototype.getChageTrStartNum = function (firstTop) {
    var startNum=null;var tollbarBtns=$("#toolbar").find("a");
    for(var num=0;num< tollbarBtns.length;num++){
        var item=$("#toolbar").find("a")[num];
        //如果当前的高度超过了 则表示分行了
        if(item.offsetTop>firstTop){
            startNum=num;
            break;
        }
    }
    if(startNum>0){
        //把多余的按钮移除掉
        for(var nums=(startNum);nums<tollbarBtns.length;nums++){
            var item=tollbarBtns[nums];
            $(item).remove();
        }
    }

    return startNum;
}
//获取排除按钮后的数组集合
PcDesFactory.prototype.getBtnsDelItem = function (commonBtns,delAry) {
    var btnIdsAry=[];
    $(commonBtns).each(function (index, item) {
        if($.inArray(item.id, delAry)<0){
            btnIdsAry.push(item);
        }
    });
    return btnIdsAry;
}
var menuCtlObj=null;
//重新初始化更多按钮集合
PcDesFactory.prototype.initToolBarAndMoreToolBar= function (areaId, _menuSimpleData,hasNum,td) {
    //再进行重绘之前  需要将更多的按钮追加到toolbar里面 才可以正确判断
    //初始化对象
    $("#toolbar").remove();
    $("#moreLabel").before(' <div id="toolbar" style="width:95%"></div>');
    var moreLabelTxt=$("#moreLabel").text();
    $("#moreLabel").remove();

    if(menuCtlObj!=null){
        $("#"+menuCtlObj).remove();
        $("#"+menuCtlObj+"_iframe_mask").remove();
        menuCtlObj=null;
    }

    $("#toolbar").after('<span class="more_style more_style_position right margin_l_5"  id="moreLabel"><a class="margin_l_5">'+moreLabelTxt+'</a><span class="ico16 arrow_2_b"></span></span>');


    tb = $("#toolbar").toolbar({
        isPager : false,
        borderLeft : false,
        borderRight : false,
        borderTop : false,
        toolbar : initAttItem(_menuSimpleData)
    });
  //是否显示文档类型切换按钮
    if(ishideconotentType){
        tb.hideBtn("conotentType");
    }
    //获取第一个按钮的上边界值
    var firstTop = 0;
    if ($("#toolbar").find("a").length > 0) {
        firstTop = $("#toolbar").find("a").get(0).offsetTop;
    }
    //获取开始的序号
    var startNum = this.getChageTrStartNum(firstTop);
    var newMenuDatas=[];
    if (startNum != null && startNum > hasNum) {
        $("#moreLabel").show();
        startNum=startNum-hasNum;

        for (var nums = startNum; nums < _menuSimpleData.length; nums++) {
            var obj = _menuSimpleData[nums];
            newMenuDatas.push(conventJsonBtnToBtn(obj,true));
        }
        menuCtlObj=$("#" + areaId).menuSimple({
            width: 100,
            direction: "BR",
            offsetLeft: -40,
            overflow:'auto',
            data: newMenuDatas
        });
    }else{
        $("#moreLabel").hide();
    }
}
//初始化新建模式下
PcDesFactory.prototype.initNewCollMoreLabel = function (areaId, _menuSimpleData,hasNum) {
    //获取第一个按钮的上边界值
    var firstTop = 0;
    if ($("#toolbar").find("a").length > 0) {
        firstTop = $("#toolbar").find("a").get(0).offsetTop;
    }
    //获取开始的序号
    var startNum = this.getChageTrStartNum(firstTop);


    if (startNum != null && startNum > hasNum) {
        $("#moreLabel").show();
        startNum=startNum-hasNum;
        var newMenuDatas=[];
        for (var nums = startNum; nums < _menuSimpleData.length; nums++) {
            var obj = _menuSimpleData[nums];
            newMenuDatas.push(conventJsonBtnToBtn(obj,true));
        }
        $("#" + areaId).menuSimple({
            
            width: 100,
            direction: "BR",
            offsetLeft: -40,
            overflow:'auto',
            data: newMenuDatas
        });
    }else{
        $("#moreLabel").hide();
    }
}
//flag 标识是从哪里进入的事项
function conventJsonBtnToBtn(obj,flag){
    var result = {};
    if(obj.type == 6 || obj.type == "6"){//磁贴
        result.id = applicationMagnetNumber;
        applicationMagnetNumber++;
        result.name = obj.label;
        // result.className = obj.label;
        result.customAttr ="data='"+obj.click+"'";
        if(flag){
            result.handle = eval("applicationAdvanceMagnet");
        }else{
            result.click = eval("applicationMagnet");
        }

        result.data = obj.click;
    }else{
        if("AddNode" == obj.id){
            result.id = obj.id;
            result.name = obj.label;
            result.name = obj.label;
            if(flag){
                result.handle = eval(obj.click);
            }else{
                result.click = eval(obj.click);
            }
            result.color = obj.color;
            result.img = obj.img;
            result.className = obj.img;
        }else{
            if(obj.id.indexOf("-") == 0){
                obj.id = "_"+obj.id.substr(1);
            }
            result.id = obj.id;
            result.name = obj.label;
            //加签代码
            if(flag){
                result.handle = eval("customOperation");
            }else{
                result.click = eval("customOperation");
            }
            result.data  = obj.click;
            result.color = obj.color;
            result.img = obj.img;
            result.className = obj.img;
        }

    }
    return result;
}
//对象初始化
var pcDesFactory=new PcDesFactory();

//设置单选按钮
function setRadio(name,sRadioValue){        //传入radio的name和选中项的值
    var oRadio = document.getElementsByName(name);
    for(var i=0;i<oRadio.length;i++){
        if(oRadio[i].value==sRadioValue) {
            oRadio[i].checked=true; //修改选中状态
            break;
        }
    }
}
function getAttitudeJSonArr(jsonObject){
    var attitudeId =  null;
    var attitudeJson = new Array();
    var radioes = document.getElementsByName("attitude");
    for(var i=0;i<radioes.length;i++){
        var nowAtt = radioes[i];
        if(nowAtt.checked){
            attitudeId =  nowAtt;
        }
        var valueAtt = nowAtt.getAttribute("value");
        var type = 0 ;
        if(valueAtt !== "" && valueAtt.indexOf("collaboration") > -1){
            type =1;
        }
        attitudeJson.push({code:nowAtt.getAttribute("code"),value:nowAtt.getAttribute("value"),type:type })

    }
    if(attitudeId){
        if(jsonObject.attitudeAction !="" &&  (attitudeId.getAttribute("value") != jsonObject.attitudeShowName) ){
            var type = 0 ;
            if(jsonObject.attitudeAction !="" && jsonObject.attitudeShowName.indexOf("collaboration") > -1){
                type =1;
            }
            var addFlag = false;
            for(var kk =0 ;kk<  attitudeJson.length ;kk++ ){
                if( attitudeJson[kk].code == jsonObject.attitudeAction && jsonObject.attitudeShowName != $.i18n(attitudeJson[kk].value) && jsonObject.attitudeShowName != attitudeJson[kk].value){
                    addFlag = true;
                    break;
                }
            }
            if(addFlag){
                //并且把他生成到状态中
                attitudeJson.push({code:jsonObject.attitudeAction,value:jsonObject.attitudeShowName,type:type,isAction:"true" })
            }

        }
    }
    return attitudeJson
}
var defaultAttitude = null;//获取的默认态度
var isPackageFlag = false;//是否是封装的态度
var defaultProcessAction = null;//获取操作的类型
var attitudeJSONArr = null;
//如果参数为真那么先弹出确认框后操作，否则先操作后弹出确认框
function showAttitude(defalutBottomHtml,result,flag){
	//流程改变+提交操作需要记录流程图的信息，方便回滚
	pushPageWorkflowInfo();
	//先执行预提交,在执行其他的方法
	 __preSubmitFormContent(function(){
     	if(flag){
     		checkedAttitude(defalutBottomHtml,result,flag);
     	}else{
     		var jsonObject  = JSON.parse(result.content);
     		var params = {};
     		params.isOperationDesignerModel =true;
     		params.changeNodeMessage =jsonObject.processActionDetail;
     		params.callback = function (){
     			checkedAttitude(defalutBottomHtml,result,flag);
     		}
     		//派发提交前的操作
     		blurButtonClick(JSON.parse(result.base_handel),jsonObject.processAction,params);
     		
     	}
     });

}
function checkedAttitude(defalutBottomHtml,result,FlagEvent){
    //弹出态度选择框--默认值为组合数据
    var dialog = $.dialog({
    targetWindow:getCtpTop(),
    id: 'againNotarizeAttitude',
    bottomHTML: defalutBottomHtml,
    url: _ctxPath +"/collaboration/collaboration.do?method=againNotarizeAttitude",
    width: 540,
    height: 150,
    title: $.i18n("collaboration.system.prompt.js"),//系统提示
    closeParam:{
        show:true,
        autoClose:true,
        handler:function(){
            //恢复资源
        	mainbody_callBack_failed();
            dialog.close();
        }
    },
    buttons: [{
        text: $.i18n('collaboration.button.ok.label'), //确定
        handler: function () {
            var rv = dialog.getReturnValue();
            document.getElementById("hidAttitude").value = rv.getAttribute("value");
            document.getElementById("hidAttitudeCode").value = rv.getAttribute("code");
            var radioes = document.getElementsByName("attitude");
            for(var i=0;i<radioes.length;i++){
                var nowAtt = radioes[i];
                var code = rv.getAttribute("code");
                if(nowAtt.getAttribute("code") == code){
                    $(nowAtt).attr("checked",true);
                    $(nowAtt).val(rv.getAttribute("value"));
                    break;
                }

            }
            dialog.close();
            if(FlagEvent){
             //重新确认态度后触发
              handleAndSubmit(result);
            }else{
                //最后有提交类就触发提交操作
                if(result.base_submit != ""){
                    var jsonObject  = JSON.parse(result.content);
                    var subParam = {};
                    subParam.changeNodeMessage = jsonObject.processActionDetail;
                    subParam.isOperationDesignerModel = true;
                    blurButtonClick(JSON.parse(result.base_submit),jsonObject.submitAction,subParam);
                }

            }

        }
    }, {
        text: $.i18n('collaboration.pushMessageToMembers.cancel'), //取消
        handler: function () {
            // handleAndSubmit(result);
        	mainbody_callBack_failed();
            dialog.close();

        }
    }]
    });
}
function customOperation(obj){

    var id = obj.id;
    if(id.lastIndexOf("_") > 0 ){
        id =  obj.id.substr(0,obj.id.lastIndexOf("_"));
    }

    if(id.indexOf("_") == 0){
        id = "-"+id.substr(1);
    }
    if(/^(-)?\d+$/.test(id)){
    	
    	// 调用平台分装的ajax方法
        var url = _ctxPath + "/rest/worklfowcomponent/permission/operation/" + id + "?option.n_a_s=1";
        
        jQuery.ajax({
            type: "GET",
            url: url,
            data: null,
            dataType: "json",
            beforeSend: CsrfGuard.beforeAjaxSend,
            async: true,
            success: function(result){
                
            	if((result != null || result != "null") && result.data){
            		result = result.data;
                    
            		// 因为改造后的方法数据结构不一致，先写死，后面改造
            		result.base_submit = "[{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"2\",\"isSystem\":true,\"key\":\"Comment\",\"label\":\"permission.operation.Comment\",\"pcClick\":\"dealDoZcdbFunc\",\"showValue\":\"暂存待办\",\"specifiesReturnToMe\":false,\"submitType\":\"1\",\"type\":\"2\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"3\",\"isSystem\":true,\"key\":\"ContinueSubmit\",\"label\":\"permission.operation.ContinueSubmit\",\"pcClick\":\"submitClickFunc\",\"showValue\":\"提交\",\"specifiesReturnToMe\":false,\"submitType\":\"1\",\"type\":\"2\"},{\"color\":\"#d4642b\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-termination\",\"id\":\"15\",\"isSystem\":true,\"key\":\"Terminate\",\"label\":\"permission.operation.Terminate\",\"pcClick\":\"stepStopFunc\",\"showValue\":\"终止\",\"specifiesReturnToMe\":false,\"submitType\":\"1\",\"type\":\"2\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-revoke\",\"id\":\"24\",\"isSystem\":true,\"key\":\"Cancel\",\"label\":\"permission.operation.Cancel\",\"pcClick\":\"dealCancelFunc\",\"showValue\":\"撤销\",\"specifiesReturnToMe\":false,\"submitType\":\"1\",\"type\":\"2\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-transfer\",\"id\":\"28\",\"isSystem\":true,\"key\":\"Transfer\",\"label\":\"permission.operation.Transfer\",\"pcClick\":\"transferFunc\",\"showValue\":\"移交\",\"specifiesReturnToMe\":false,\"submitType\":\"1\",\"type\":\"2\"}]";
            		result.base_handel = "[{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"1\",\"isSystem\":true,\"key\":\"Track\",\"label\":\"permission.operation.Track\",\"pcClick\":\"trackBoxFunc\",\"showValue\":\"跟踪\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"4\",\"isSystem\":true,\"key\":\"Archive\",\"label\":\"permission.operation.Archive\",\"pcClick\":\"\",\"showValue\":\"处理后归档\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"5\",\"isSystem\":true,\"key\":\"Opinion\",\"label\":\"permission.operation.Opinion\",\"pcClick\":\"\",\"showValue\":\"意见\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"3\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"6\",\"isSystem\":true,\"key\":\"CommonPhrase\",\"label\":\"permission.operation.CommonPhrase\",\"pcClick\":\"\",\"showValue\":\"常用语\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"3\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"7\",\"isSystem\":true,\"key\":\"UploadAttachment\",\"label\":\"permission.operation.UploadAttachment\",\"pcClick\":\"\",\"showValue\":\"上传附件\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"3\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"8\",\"isSystem\":true,\"key\":\"Print\",\"label\":\"permission.operation.Print\",\"pcClick\":\"\",\"showValue\":\"打印\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"9\",\"isSystem\":true,\"key\":\"UploadRelDoc\",\"label\":\"permission.operation.UploadRelDoc\",\"pcClick\":\"\",\"showValue\":\"关联文档\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"3\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"10\",\"isSystem\":true,\"key\":\"EditWorkFlow\",\"label\":\"permission.operation.EditWorkFlow\",\"pcClick\":\"\",\"showValue\":\"编辑流程\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"11\",\"isSystem\":true,\"key\":\"Pigeonhole\",\"label\":\"permission.operation.Pigeonhole\",\"pcClick\":\"\",\"showValue\":\"归档\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"12\",\"isSystem\":true,\"key\":\"RepeatSend\",\"label\":\"permission.operation.RepeatSend\",\"pcClick\":\"\",\"showValue\":\"重复发起\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"13\",\"isSystem\":true,\"key\":\"ReMove\",\"label\":\"permission.operation.ReMove\",\"pcClick\":\"\",\"showValue\":\"删除\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"hasProcessChange\":false,\"hasSubmit\":false,\"id\":\"14\",\"isSystem\":true,\"key\":\"AppTile\",\"label\":\"permission.operation.AppTile\",\"pcClick\":\"\",\"showValue\":\"应用磁贴\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"1\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-notification\",\"id\":\"16\",\"isSystem\":true,\"key\":\"Infom\",\"label\":\"permission.operation.Infom\",\"pcClick\":\"addInformFunc\",\"showValue\":\"知会\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"0\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-signature\",\"id\":\"17\",\"isSystem\":true,\"key\":\"AddNode\",\"label\":\"permission.operation.AddNode\",\"pcClick\":\"addNode\",\"showValue\":\"加签\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"0\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-current_countersigned\",\"id\":\"18\",\"isSystem\":true,\"key\":\"JointSign\",\"label\":\"permission.operation.JointSign\",\"pcClick\":\"currentAssign\",\"showValue\":\"当前会签\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"0\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-signafalse\",\"id\":\"19\",\"isSystem\":true,\"key\":\"RemoveNode\",\"label\":\"permission.operation.RemoveNode\",\"pcClick\":\"deleteNodeFunc\",\"showValue\":\"减签\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"0\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-apply-meeting\",\"id\":\"20\",\"isSystem\":true,\"key\":\"moreSign\",\"label\":\"permission.operation.moreSign\",\"pcClick\":\"addMoreNode\",\"showValue\":\"多级会签\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"0\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-forwarding\",\"id\":\"21\",\"isSystem\":true,\"key\":\"Forward\",\"label\":\"permission.operation.Forward\",\"pcClick\":\"dealForwardFunc\",\"showValue\":\"转发\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"1\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-modify_text\",\"id\":\"22\",\"isSystem\":true,\"key\":\"Edit\",\"label\":\"permission.operation.Edit\",\"pcClick\":\"editContentFunc\",\"showValue\":\"修改正文\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-signa\",\"id\":\"23\",\"isSystem\":true,\"key\":\"Sign\",\"label\":\"permission.operation.Sign\",\"pcClick\":\"openSignature\",\"showValue\":\"签章\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-setting\",\"id\":\"25\",\"isSystem\":true,\"key\":\"SuperviseSet\",\"label\":\"permission.operation.SuperviseSet\",\"pcClick\":\"superviseSetFunc\",\"showValue\":\"督办设置\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-modify_attachment\",\"id\":\"26\",\"isSystem\":true,\"key\":\"allowUpdateAttachment\",\"label\":\"permission.operation.allowUpdateAttachment\",\"pcClick\":\"modifyAttFunc\",\"showValue\":\"修改附件\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"4\"},{\"color\":\"#1f85ec\",\"hasProcessChange\":false,\"hasSubmit\":false,\"icon\":\"syIcon sy-forward_event\",\"id\":\"27\",\"isSystem\":true,\"key\":\"Transform\",\"label\":\"permission.operation.Transform\",\"pcClick\":\"transformFunc\",\"showValue\":\"转事件\",\"specifiesReturnToMe\":false,\"submitType\":\"0\",\"type\":\"1\"}]";

            		isPackageFlag =false;
                	var specialNodePolicyMsg = checkSpecialNodePolicy(result);
                	if(specialNodePolicyMsg){
                		$.alert(specialNodePolicyMsg);
                		return;
                	}
                	
                    var jsonObject  = JSON.parse(result.content);
                    if((nodeattitudeListSize == "0" || nodeattitudeListSize == "") && jsonObject.attitudeAction != ""){
                        //如果节点没有态度-但是封装操作有态度那么传入封装的态度
                        document.getElementById("hidAttitude").value = jsonObject.attitudeShowName;
                        document.getElementById("hidAttitudeCode").value = jsonObject.attitudeAction;
                        // $("#hidAttitude").val()
                    }
                     if(!( jsonObject.attitudeAction == "" || nodeattitudeListSize == "0" || nodeattitudeListSize == "")){
                        defaultAttitude = jsonObject.attitudeAction;
                        isPackageFlag = true;
                     }
                    //如果态度为空 或者没有态度权限，那么直接跳过态度 --如果是回退操作也不出现态度
                    if(!( jsonObject.attitudeAction == "" || nodeattitudeListSize == "0" || nodeattitudeListSize == "") && jsonObject.submitAction !="Return" ){

                        var attitudeId =  null;
                        var showFlagAttitude = false;
                        var showEqAttitude = false;
                        var attitudeJson = new Array();
                        var radioes = document.getElementsByName("attitude");
                        for(var i=0;i<radioes.length;i++){
                            var nowAtt = radioes[i];
                            if(nowAtt.checked){
                                attitudeId =  nowAtt;
                            }
                            var valueAtt = nowAtt.getAttribute("value");
                            var type = 0 ;
                            if(valueAtt !== "" && valueAtt.indexOf("collaboration") > -1){
                                type =1;
                            }
                            attitudeJson.push({code:nowAtt.getAttribute("code"),value:nowAtt.getAttribute("value"),type:type })

                        }
                        if(attitudeId){
                            if(jsonObject.attitudeAction != attitudeId.getAttribute("code") ){
                                showFlagAttitude = true;
                            }
                            //默认值不想等
                            if(attitudeId.getAttribute("value") != jsonObject.attitudeShowName ){
                            if(jsonObject.attitudeAction !="" &&  (attitudeId.getAttribute("value") != jsonObject.attitudeShowName) ){
                                showFlagAttitude = true;
                                var type = 0 ;
                                if(jsonObject.attitudeAction !="" && jsonObject.attitudeShowName.indexOf("collaboration") > -1){
                                    type =1;
                                }
                                var addFlag = false;
                                for(var kk =0 ;kk<  attitudeJson.length ;kk++ ){
                                    if( attitudeJson[kk].code == jsonObject.attitudeAction && attitudeId.getAttribute("code") ==attitudeJson[kk].code   && (jsonObject.attitudeShowName == $.i18n(attitudeJson[kk].value )|| jsonObject.attitudeShowName == attitudeJson[kk].value ) ){
                                        defaultAttitude = attitudeJson[kk].code;
                                        showEqAttitude = true;
                                    }
                                    if( (defaultAttitude == $.i18n(attitudeJson[kk].code )|| defaultAttitude == attitudeJson[kk].code )){
                                        defaultAttitude = attitudeJson[kk].code;
                                    }
                                    if( attitudeJson[kk].code == jsonObject.attitudeAction && jsonObject.attitudeShowName != $.i18n(attitudeJson[kk].value) && jsonObject.attitudeShowName != attitudeJson[kk].value){
                                        addFlag = true;
                                        break;
                                    }
                                }
                                if(addFlag){
                                    //并且把他生成到状态中
                                	//type:是否是国际化显示值   isAction:节点封装的态度
                                    attitudeJson.push({code:jsonObject.attitudeAction,value:jsonObject.attitudeShowName,type:type,isAction:"true"})
                                }

                            }
                        }
                        attitudeJSONArr = attitudeJson;
                       /**
                        * 是否弹出态度确认框
                        * 1. 封装的态度和选择的态度不一致 弹出态度确认框
                        * 2. 态度一致，操作是回退、撤销、终止时 态度是不同意 不弹出态度确认框
                        * 3. 态度一致，操作不是回退、撤销、终止时 态度是不同意 (提交配置不同意策略 弹出不同意策略的选择，未配置时直接提交)
                        * 4. 态度一致，操作是回退、撤销、终止 态度是非不同意 弹出态度确认框
                        * 5. 态度一致，操作不是回退、撤销、终止 态度时非不同意 不弹出态度确认框
                        */
                        var isReturnTerminateAndCancel = jsonObject.submitAction == "Return" || jsonObject.submitAction == "Terminate" || jsonObject.submitAction == "Cancel";
                        if(attitudeId.getAttribute("value") == jsonObject.attitudeShowName ){
                        	if(jsonObject.submitAction == "ContinueSubmit"){
                        		showFlagAttitude = false;
                        	}else if(isReturnTerminateAndCancel&&attitudeId.getAttribute("code") == "disagree"){//操作是回退、撤销、终止时 态度是不同意 不弹出态度确认框
                        		showFlagAttitude = false;
                        	}else if(!isReturnTerminateAndCancel&&attitudeId.getAttribute("code") == "disagree"){//操作不是回退、撤销、终止时 态度是不同意 弹出态度确认框
                        		showFlagAttitude = true;
                        	}else if(isReturnTerminateAndCancel&&attitudeId.getAttribute("code") != "disagree"){//操作是回退、撤销、终止 态度是非不同意 弹出态度确认框
                        		showFlagAttitude = true
                        	}else if(!isReturnTerminateAndCancel&&attitudeId.getAttribute("code") != "disagree"){//操作不是回退、撤销、终止 态度时非不同意 不弹出态度确认框
                        		showFlagAttitude = false;
                        	}
                        }
                        defaultProcessAction = jsonObject.submitAction;
                        var defalutBottomHtml = '';
                        if(defaultProcessAction == "Cancel"){
                            defalutBottomHtml = '<label  class="margin_t_5 hand" style="display: inline-block;width: 190px;text-align: left;position: relative;top: -7px;">'+$.i18n("collaboration.workflow.trace.hadToRunBack")+'</label>';;
                        }

                        if( showFlagAttitude){
                        	  //如果是提交类型
                        	if(jsonObject.submitAction != "" && jsonObject.processAction == ""){
                        		 showAttitude(defalutBottomHtml,result,true);
                        	}else{
                        		showAttitude(defalutBottomHtml,result,false);
                        	}

                        }else{
                            //不验证态度直接触发
                            handleAndSubmit(result)
                        }
                        } else {
                        	//不验证态度直接触发
                            handleAndSubmit(result);
                        }
                        isPackageFlag = true;
                    }else{
                       if(defaultAttitude == "" || defaultAttitude == null){
                             defaultAttitude =  $('input[name="attitude"]:checked').attr("code");
                       }
                       attitudeJSONArr = getAttitudeJSonArr(jsonObject);
                        //不验证态度直接触发
                       handleAndSubmit(result)
                    }
                }
            }
        });
    }
}

function checkSpecialNodePolicy(result){
	
	var msg = "";
	var tempIsTemplate = !(!templateId || templateId == '' || templateId == "0" || templateId == "-1");
	var isForm = bodyType=="20";
	if(tempIsTemplate&&isForm){
		return msg;
	}
	var jsonObject  = JSON.parse(result.content);
	var specialNodePolicy = new Array();
	if(tempIsTemplate){
		specialNodePolicy = ["formaudit","vouch"];
	}else{
		specialNodePolicy = ["formaudit","vouch","newsaudit","bulletionaudit"];
	}
	//然后判断操作
    if(jsonObject.submitAction !="Return" && jsonObject.processAction != ""){
        var changeNodeMessage = jsonObject.processActionDetail;
        if(changeNodeMessage && changeNodeMessage.policyId){
        	var policy = changeNodeMessage.policyId;
        	var policyArray = [];
        	if(policy && jsonObject.processAction!="moreSign"){
        		policyArray.push(policy);
        	}else if(policy){
        		policyArray = policy;
        	}
        	var colTypeName = $.i18n("collaboration.eventsource.category.collaboration");
        	if(tempIsTemplate){
        		colTypeName = $.i18n("collaboration.saveAsTemplate.collTemplate");
        	}
        	for(var i=0;i<policyArray.length;i++){
        		if($.inArray(policyArray[i], specialNodePolicy)>=0){
            		msg = $.i18n("collaboration.canNotDeal.specialNodePolicy.js",$.i18n("node.policy."+policyArray[i]),colTypeName);
            		break;
            	}
        	}
        	
        }
    }
    
    return msg;
}

function handleAndSubmit(result){
    var jsonObject  = JSON.parse(result.content);
    if(jsonObject.submitAction !="Return"){
        var params = {};
        params.isOperationDesignerModel =true;
        params.changeNodeMessage =jsonObject.processActionDetail;
        //然后判断操作的
        if(jsonObject.processAction != ""){
            //如果操作后有提交那么回调方法就不在刷新流程图直接提交了
            if(jsonObject.submitAction != ""){
                //流程改变+提交操作需要记录流程图的信息，方便回滚
            	pushPageWorkflowInfo();
                params.callback = function (){
                    var subParam = {};
                    subParam.changeNodeMessage = params.changeNodeMessage;
                    subParam.isOperationDesignerModel = params.isOperationDesignerModel;
                    blurButtonClick(JSON.parse(result.base_submit),jsonObject.submitAction,subParam);
                }
            }
            
            __preSubmitFormContent(function(){
            	blurButtonClick(JSON.parse(result.base_handel),jsonObject.processAction,params);
            })
            
        }
        
        //如果只有提交操作那么直接派发
        if(jsonObject.processAction == "" && jsonObject.submitAction != ""){
            blurButtonClick(JSON.parse(result.base_submit),jsonObject.submitAction,params)
        }
        
    }else{
        var params = {};
        params.changeNodeMessage = true;
        //回退 - 回退上节点
        if(jsonObject.returnDetailData === "Return"){
            stepBackCallBack();
        }else{
            var returnArr = jsonObject.returnDetailData.split("|");
            params.showReGo = true;
            params.showToMe = true;

            if(returnArr[1] == "0"){
                params.showToMe = "false";
            }else if(returnArr[1] == "1"){
                params.showReGo = "false";
            }
            if("SpecifiesReturn" ===  returnArr[0]){//回退到指定人
                specifiesReturnFunc(params);
            }else if("SpecifiesReturnCreate" ===  returnArr[0]){//回退到发起人
            	params.stepBackToNodeId = "start";
                specifiesReturnFunc(params);
            }
        }

    }
}
//模拟派发手动点击事件
function blurButtonClick(list,key,params){
    var size  = list.length;
    for(var i = 0 ;i< size ;i++){
        var obj = list[i];
        if(obj.key == key){
            if(obj.pcClick != ""){
                var fn = eval(obj.pcClick);
                new fn(params);
            }
            return true;
        }
    }

}
function getRadioValue(name){
    var radioes = document.getElementsByName(name);
    for(var i=0;i<radioes.length;i++){
        if(radioes[i].checked){
            return radioes[i].value;
        }
    }
    return false;
}
function getRadioValueCode(name){
	var radioes = document.getElementsByName(name);
	for(var i=0;i<radioes.length;i++){
		if(radioes[i].checked){
			return radioes[i].getAttribute("code");
		}
	}
	return false;
}
function getRadioObject(name){
    var radioes = document.getElementsByName(name);
    for(var i=0;i<radioes.length;i++){
        if(radioes[i].checked){
            return radioes[i];
        }
    }
    return false;
}
//引用磁贴的查询
function applicationMagnet(obj){
    var url = $(obj).attr("data");
    openLink(url);
}
//引用磁贴的查询-高级操作
function applicationAdvanceMagnet(obj){
    var url = $(obj.obj).attr("data");
    openLink(url);
}

function openLink(url) {
	//校验是否是能访问的URL——磁贴中存在【指定URL】类型
	var strRegex = '(https?)://[-A-Za-z0-9+&@#/%?=~_|!:,.;]+[-A-Za-z0-9+&@#/%=~_|]';
	var re = new RegExp(strRegex);
	if (re.test(url)) {
		window.open(url)
	} else {
		window.open(_ctxPath +url)
	}
}

/**
 * 判断封装类操作是否需要置灰
 * 主要用于指定回退状态4种状态：
 * 	subState：15、
 *  subState：16、
 *  subState：17、
 *  inInSpecialSB：指定回退-直接提交给我，回退者是复合节点，复合节点中其他人员状态
 * @returns 是否置灰
 */
function checkButtonCanUse(buttonObj) {
	if(inInSpecialSB || (state =='3' && (subState == "15" || subState == "16" || subState == "17"))){
		if (inInSpecialSB) {
			//回退与指定回退
			if ($.inArray("Return", buttonObj.codes) > -1) {
				return false;
			}
		} else {
			//移交\加签\减签\当前会签\知会\多级会签 及其封装操作,都不允许操作
			var flowChangeArr = ["Transfer","AddNode","RemoveNode","JointSign","Infom","moreSign"];
			if (buttonObj.isFlowChange || $.inArray(buttonObj.id, flowChangeArr)  > -1 ) {
				return false;
			}
			if(buttonObj.codes && buttonObj.codes.length>0){
                for(var n =0 ; n< buttonObj.codes.length ; n++){
                    if( $.inArray(buttonObj.codes[n], flowChangeArr)  > -1 ){
                        return false;
                    }
                }
			}
			
			if (subState == "16"){
				//指定回退只能做提交给我
                if ($.inArray("Return", buttonObj.codes) > -1 && !buttonObj.isSpecifiesReturnToMe) {
                    return false;
                }
			} else {
				//提交\签章\督办设置\修改正文\修改附件
				var dontUseArr = ["ContinueSubmit","Sign","SuperviseSet","Edit","allowUpdateAttachment"];
				if (buttonObj.hasSubmit) {//提交
					return false;
				} else if ($.inArray("Return", buttonObj.codes) > -1) {//回退与指定回退
					return false;
				} else if ($.inArray(buttonObj.id, dontUseArr)  > -1) {
					return false;
				}
			}
		}
	}
	
	return true;
}




